/*!
 * echarts-extension-amap 
 * @version 1.11.0
 * @author plainheart
 * 
 * MIT License
 * 
 * Copyright (c) 2019-2022 Zhongxiang.Wang
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("echarts/lib/echarts")):"function"==typeof define&&define.amd?define(["exports","echarts"],t):t(((e="undefined"!=typeof globalThis?globalThis:e||self).echarts=e.echarts||{},e.echarts.amap={}),e.echarts)}(this,(function(e,t){"use strict";var n=t.version.split("."),a=n[0]>4;var o={};function i(e,t,n){var a="[ECharts][Extension][AMap]".concat(e?" "+e+":":""," ").concat(t);n&&o[a]||console.warn(a),n&&(o[a]=!0)}function r(e,n){return n=n||[0,0],t.util.map([0,1],(function(t){var a=n[t],o=e[t]/2,i=[],r=[];return i[t]=a-o,r[t]=a+o,i[1-t]=r[1-t]=n[1-t],Math.abs(this.dataToPoint(i)[t]-this.dataToPoint(r)[t])}),this)}var s=["echartsLayerZIndex","echartsLayerInteractive","renderOnMoving","largeMode","returnMapCameraState","layers"];function c(e,t){this._amap=e,this._api=t,this._mapOffset=[0,0]}var p=c.prototype;p.setZoom=function(e){this._zoom=e},p.setCenter=function(e){var t=new AMap.LngLat(e[0],e[1]);this._center=this._amap.lngLatToContainer(t)},p.setMapOffset=function(e){this._mapOffset=e},p.setAMap=function(e){this._amap=e},p.getAMap=function(){return this._amap},p.dataToPoint=function(e){var t=new AMap.LngLat(e[0],e[1]),n=this._amap.lngLatToContainer(t),a=this._mapOffset;return[n.x-a[0],n.y-a[1]]},p.pointToData=function(e){var t=this._mapOffset,n=this._amap.containerToLngLat(new AMap.Pixel(e[0]+t[0],e[1]+t[1]));return[n.lng,n.lat]},p.getViewRect=function(){var e=this._api;return new t.graphic.BoundingRect(0,0,e.getWidth(),e.getHeight())},p.getRoamTransform=function(){return t.matrix.create()},p.prepareCustoms=function(){var e=this.getViewRect();return{coordSys:{type:"amap",x:e.x,y:e.y,width:e.width,height:e.height},api:{coord:t.util.bind(this.dataToPoint,this),size:t.util.bind(r,this)}}},p.convertToPixel=function(e,t,n){return this.dataToPoint(n)},p.convertFromPixel=function(e,t,n){return this.pointToData(n)},c.create=function(e,n){var a;return e.eachComponent("amap",(function(e){if("undefined"==typeof AMap)throw new Error("AMap api is not loaded");if(a)throw new Error("Only one amap component is allowed");var o=e.getAMap(),r=e.get("echartsLayerInteractive");if(!o){var p=n.getDom(),m=n.getZr().painter,h=m.getViewportRoot();h.className="amap-ec-layer",h.style.visibility="hidden";var l=p.querySelector(".ec-extension-amap");l&&(h.style.left="0px",h.style.top="0px",p.removeChild(l)),(l=document.createElement("div")).className="ec-extension-amap",l.style.cssText="position:absolute;top:0;left:0;bottom:0;right:0;",p.appendChild(l);var d=t.util.clone(e.get());"echartsLayerZIndex"in d&&i("DEPRECATED","the option `echartsLayerZIndex` has been removed since v1.9.0, use `echartsLayerInteractive` instead."),t.util.each(s,(function(e){delete d[e]})),(o=new AMap.Map(l,d)).on("complete",(function(){l.querySelector(".amap-maps").appendChild(h),h.style.visibility=""})),e.setAMap(o),e.setEChartsLayer(h),m.getViewportRootOffset=function(){return{offsetLeft:0,offsetTop:0}}}e.__echartsLayerInteractive!==r&&(e.setEChartsLayerInteractive(r),e.__echartsLayerInteractive=r);var f=e.get("center"),u=e.get("zoom");if(f&&u){var v=o.getCenter(),g=o.getZoom();e.centerOrZoomChanged([v.lng,v.lat],g)&&o.setZoomAndCenter(u,new AMap.LngLat(f[0],f[1]))}var y=e.__mapStyle,_=e.get("mapStyle");if(y!==_&&o.setMapStyle(e.__mapStyle=_),o.setLang){var L=e.__mapLang,C=e.get("lang");L!==C&&o.setLang(e.__mapLang=C)}else i("CAVEAT","The current map doesn't support `setLang` API!",!0);(a=new c(o,n)).setMapOffset(e.__mapOffset||[0,0]),a.setZoom(u),a.setCenter(f),e.coordinateSystem=a})),e.eachSeries((function(e){"amap"===e.get("coordinateSystem")&&(e.coordinateSystem=a)})),a&&[a]},p.dimensions=c.dimensions=["lng","lat"],p.type="amap";var m,h={type:"amap",setAMap:function(e){this.__amap=e},getAMap:function(){return this.__amap},setEChartsLayer:function(e){this.__echartsLayer=e},getEChartsLayer:function(){return this.__echartsLayer},setEChartsLayerVisiblity:function(e){this.__echartsLayer.style.display=e?"block":"none"},setEChartsLayerInteractive:function(e){this.option.echartsLayerInteractive=!!e,this.__echartsLayer.style.pointerEvents=e?"auto":"none"},setCenterAndZoom:function(e,t){this.option.center=e,this.option.zoom=t},centerOrZoomChanged:function(e,t){var n,a,o=this.option;return a=o.center,!((n=e)&&a&&n[0]===a[0]&&n[1]===a[1]&&t===o.zoom)},defaultOption:{center:[116.397428,39.90923],zoom:5,isHotspot:!1,resizeEnable:!0,echartsLayerInteractive:!0,renderOnMoving:!0,largeMode:!1,returnMapCameraState:!1}},l=a?t.ComponentModel.extend(h):h,d={type:"amap",init:function(){this._isFirstRender=!0,m=AMap.version>=2},render:function(e,n,a){var o=!0,i=e.getAMap(),r=a.getZr().painter.getViewportRoot(),s=i.getContainer(),c=e.coordinateSystem,p=e.get("renderOnMoving"),h=e.get("resizeEnable"),l=e.get("largeMode"),d=e.get("returnMapCameraState"),f=i.getViewMode_(),u="3D"===f,v=function(t){if(!o){var n=s.style,p=[-parseInt(n.left,10)||0,-parseInt(n.top,10)||0],m=r.style,h=p[0]+"px",l=p[1]+"px";m.left!==h&&(m.left=h),m.top!==l&&(m.top=l),c.setMapOffset(e.__mapOffset=p);var u={type:"amapRoam",animation:{duration:0}};if(d){var v=(t=t||{}).center;v||(v=[(v=i.getCenter()).lng,v.lat]),u.camera={viewMode:f,center:v,zoom:t.zoom||i.getZoom(),rotation:null==t.rotation?i.getRotation():t.rotation,pitch:null==t.pitch?i.getPitch():t.pitch,scale:i.getScale(),bounds:i.getBounds()}}a.dispatchAction(u)}};if(i.off("mapmove",this._moveHandler),i.off("moveend",this._moveHandler),i.off("viewchange",this._moveHandler),i.off("camerachange",this._moveHandler),i.off("zoom",this._moveHandler),this._resizeHandler&&i.off("resize",this._resizeHandler),this._moveStartHandler&&i.off("movestart",this._moveStartHandler),this._moveEndHandler&&(i.off("moveend",this._moveEndHandler),i.off("zoomend",this._moveEndHandler)),i.on(p?m?"viewchange":u?"camerachange":"mapmove":"moveend",!m&&l?v=t.throttle(v,20,!0):v),this._moveHandler=v,!p||m&&u||i.on("zoom",v),!p){i.on("movestart",this._moveStartHandler=function(){setTimeout((function(){e.setEChartsLayerVisiblity(!1)}),0)});var g=this._moveEndHandler=function(t){(!t||"moveend"!==t.type)&&v(t),setTimeout((function(){e.setEChartsLayerVisiblity(!0)}),m||!l?0:20)};if(i.on("moveend",g),i.on("zoomend",g),this._isFirstRender&&u){var y=i.setPitch,_=i.setRotation;i.setPitch=function(){y.apply(this,arguments),g()},i.setRotation=function(){_.apply(this,arguments),g()}}}if(h){var L=function(){t.getInstanceByDom(a.getDom()).resize()};!m&&l&&(L=t.throttle(L,20,!0)),i.on("resize",this._resizeHandler=L)}this._isFirstRender=o=!1},dispose:function(){o={};var e=this.__model;e&&(e.getAMap().destroy(),e.setAMap(null),e.setEChartsLayer(null),e.coordinateSystem&&(e.coordinateSystem.setAMap(null),e.coordinateSystem=null),delete this._moveHandler,delete this._resizeHandler,delete this._moveStartHandler,delete this._moveEndHandler)}},f=a?t.ComponentView.extend(d):d;function u(e){(!a||5==n[0]&&n[1]<4)&&e.registerLayout((function(e,t){e.eachSeriesByType("pie",(function(e){var t=e.coordinateSystem,n=e.getData(),a=n.mapDimension("value");if(t&&"amap"===t.type){var o=e.get("center"),i=t.dataToPoint(o),r=i[0],s=i[1];n.each(a,(function(e,t){var a=n.getItemLayout(t);a.cx=r,a.cy=s}))}}))})),a?e.registerComponentModel(l):e.extendComponentModel(l),a?e.registerComponentView(f):e.extendComponentView(f),e.registerCoordinateSystem("amap",c),e.registerAction({type:"amapRoam",event:"amapRoam",update:"updateLayout"},(function(e,t){t.eachComponent("amap",(function(e){var t=e.getAMap(),n=t.getCenter();e.setCenterAndZoom([n.lng,n.lat],t.getZoom())}))}))}a?t.use(u):u(t),e.name="echarts-extension-amap",e.version="1.11.0",Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=echarts-extension-amap.min.js.map
